       IDENTIFICATION DIVISION.
       PROGRAM-ID. GIORNI-ANNO.
       AUTHOR. DEBORAH.
      *-----------------------------------------------------------------*
      *   CALCOLA GIORNI TOTALI DALL'INIZIO DELL'ANNO A PARTIRE
      *   DA UNA DATA INSERITA IN INPUT DA TASTIERA.
      *-----------------------------------------------------------------*
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. PC-IBM.
       OBJECT-COMPUTER. PC-IBM.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  WS-GIORNI PIC 9(3).
       01  WS-QUOZIENTE PIC 9(4).
       01  WS-RESTO PIC 9(4).
       01  WS-FLAG-BIS PIC 9(1).
       01  WS-INDICE PIC 9(2).
       01  WS-STRINGA-GIORNI PIC X(36)
               VALUE "000031059090120151181212243273304334".
       01  WS-ANNO REDEFINES WS-STRINGA-GIORNI.
           02 WS-GIORNI-ANNO PIC 9(3) OCCURS 12 TIMES.
       01 WS-DATA.
           02 WS-GG PIC 9(2).
           02 WS-B1 PIC X(1).
           02 WS-MM PIC 9(2).
           02 WS-B2 PIC X(1).
           02 WS-AAAA PIC 9(4).
       PROCEDURE DIVISION.
       MAIN.
           PERFORM OP-INIZIALI.
           PERFORM ELABORA-DATA.
           PERFORM OP-FINALI.
       EX-MAIN.
           EXIT PROGRAM.
           STOP RUN.
      *-----------------------------------------------------------------*
      *   INIZIO DEI SOTTOPROGRAMMI
      *-----------------------------------------------------------------*
       OP-INIZIALI.
           MOVE 0 TO WS-GIORNI WS-FLAG-BIS WS-QUOZIENTE WS-INDICE.
       FINE-OP-INIZIALI.
           EXIT.
       ELABORA-DATA.
           DISPLAY "INSERISCI DATA (FORMATO:GG/MM/AAAA):".
           ACCEPT WS-DATA LINE 25 POSITION 40.
           PERFORM ANNO-BISEST.
           PERFORM CALCOLA-GIORNI.
       FINE-ELABORA-DATA.
           EXIT.
       ANNO-BISEST.
           DIVIDE 4 INTO WS-AAAA GIVING WS-QUOZIENTE
               REMAINDER WS-RESTO
           IF WS-RESTO = 0
               DIVIDE 100 INTO WS-AAAA GIVING WS-QUOZIENTE
                   REMAINDER WS-RESTO
               IF WS-RESTO = 0
                   DIVIDE 400 INTO WS-AAAA GIVING WS-QUOZIENTE
                       REMAINDER WS-RESTO
                   IF WS-RESTO = 0
                       MOVE 1 TO WS-FLAG-BIS
                   END-IF
               ELSE
                   MOVE 1 TO WS-FLAG-BIS
               END-IF
           END-IF.
       FINE-ANNO-BISEST.
           EXIT.
       CALCOLA-GIORNI.
           IF WS-FLAG-BIS = 1
               PERFORM AGGIORNA
                  VARYING WS-INDICE FROM 3 BY 1 UNTIL WS-INDICE >= 13
           END-IF.
           COMPUTE WS-GIORNI = WS-GG + WS-GIORNI-ANNO(WS-MM).
       FINE-CALCOLA-GIORNI.
           EXIT.
       AGGIORNA.
           COMPUTE
              WS-GIORNI-ANNO(WS-INDICE) = WS-GIORNI-ANNO(WS-INDICE) + 1.
       FINE-AGGIORNA.
           EXIT.
       OP-FINALI.
           DISPLAY "NUMERO GIORNI TRASCORSI DA INIZIO ANNO:" WS-GIORNI.
           DISPLAY "FLAG" WS-FLAG-BIS.
       FINE-OP-FINALI.
           EXIT.
