       IDENTIFICATION DIVISION.
       PROGRAM-ID. GIORNILA.
       AUTHOR. LAURA.
      *-----------------------------------------------------------------*
      *   "SCHELETRO" DI UN PROGRAMMA COBOL.
      *-----------------------------------------------------------------*
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. PC-IBM.
       OBJECT-COMPUTER. PC-IBM.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  WS-DATA.
           02 WS-GG   PIC 9(2) VALUE 0.
           02 WS-SB1  PIC X(1) VALUE '/'.
           02 WS-MM   PIC 9(2) VALUE 0.
           02 WS-SB2  PIC X(1) VALUE '/'.
           02 WS-AAAA PIC 9(4) VALUE 0.
       01  WS-TOT-GIORNI PIC 9(3) VALUE 0.
       01  WS-GIORNI-MESE.
           02 FILLER PIC 9(2) VALUE 1.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 2.
           02 FILLER PIC 9(2) VALUE 28.
           02 FILLER PIC 9(2) VALUE 3.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 4.
           02 FILLER PIC 9(2) VALUE 30.
           02 FILLER PIC 9(2) VALUE 5.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 6.
           02 FILLER PIC 9(2) VALUE 30.
           02 FILLER PIC 9(2) VALUE 7.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 8.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 9.
           02 FILLER PIC 9(2) VALUE 30.
           02 FILLER PIC 9(2) VALUE 10.
           02 FILLER PIC 9(2) VALUE 31.
           02 FILLER PIC 9(2) VALUE 11.
           02 FILLER PIC 9(2) VALUE 30.
           02 FILLER PIC 9(2) VALUE 12.
           02 FILLER PIC 9(2) VALUE 31.
       01  WS-TABELLA-GIORNI-MESE REDEFINES WS-GIORNI-MESE.
           02 WS-MESE OCCURS 12 TIMES.
              03 WS-NUM-MESE PIC 9(2).
              03 WS-GIORNI PIC 9(2).
       01  WS-IND PIC 9(2) VALUE 1.
       01  WS-QUOZ1 PIC 9(3) VALUE 0.
       01  WS-QUOZ2 PIC 9(3) VALUE 0.
       01  WS-QUOZ3 PIC 9(3) VALUE 0.
       01  WS-RESTO1 PIC 9(3) VALUE 0.
       01  WS-RESTO2 PIC 9(3) VALUE 0.
       01  WS-RESTO3 PIC 9(3) VALUE 0.
       PROCEDURE DIVISION.
       MAIN.
           PERFORM OP-INIZIALI.
           PERFORM ELABORA-DATA.
           PERFORM OP-FINALI.
       EX-MAIN.
           EXIT PROGRAM.
           STOP RUN.
      *-----------------------------------------------------------------*
      *   INIZIO DEI SOTTOPROGRAMMI
      *-----------------------------------------------------------------*
       OP-INIZIALI.
       FINE-OP-INIZIALI.
           EXIT.
       ELABORA-DATA.
           DISPLAY 'SCRIVI DATA:'.
           ACCEPT WS-DATA LINE 25 POSITION 25.
           PERFORM ELABORA-MESE VARYING WS-IND FROM 1 BY 1 UNTIL
           WS-NUM-MESE(WS-IND) NOT < WS-MM.
           COMPUTE WS-TOT-GIORNI = WS-TOT-GIORNI + WS-GG.
           PERFORM ELABORA-RESTI.
           PERFORM ELABORA-ANNO.
       FINE-ELABORA-DATA.
           EXIT.
       ELABORA-MESE.
           COMPUTE WS-TOT-GIORNI = WS-TOT-GIORNI + WS-GIORNI(WS-IND).
       FINE-ELABORA-MESE.
           EXIT.
       ELABORA-RESTI.
           DIVIDE 100 INTO WS-AAAA GIVING WS-QUOZ1 REMAINDER WS-RESTO1.
           DIVIDE 400 INTO WS-AAAA GIVING WS-QUOZ2 REMAINDER WS-RESTO2.
           DIVIDE 4 INTO WS-AAAA GIVING WS-QUOZ3 REMAINDER WS-RESTO3.
       FINE-ELABORA-RESTI.
           EXIT.
       ELABORA-ANNO.
           IF WS-RESTO1 = 0
              IF WS-RESTO2 = 0
                 PERFORM CONTROLLO
              ELSE
                 NEXT SENTENCE
              END-IF
           ELSE
               IF WS-RESTO3 = 0
                  PERFORM CONTROLLO
               ELSE
                  NEXT SENTENCE
               END-IF
           END-IF.
       FINE-ELABORA-ANNO.
           EXIT.
       CONTROLLO.
           IF WS-MM > 2
             COMPUTE WS-TOT-GIORNI = WS-TOT-GIORNI + 1
           ELSE
              NEXT SENTENCE
           END-IF.
       FINE-CONTROLLO.
           EXIT.
       OP-FINALI.
           DISPLAY 'IL NUMERO DI GIORNI :' WS-TOT-GIORNI.
       FINE-OP-FINALI.
           EXIT.
