       ID DIVISION.
       PROGRAM-ID.       PROGRAM1.
       AUTHOR.           RSI SISTEMI.
      *-----------------------------------------------------------------*
      *  Programma LEGGI/SCRIVI da un file sequenziale ad uno ad INDICI
      *-----------------------------------------------------------------*
      *DATE-WRITTEN.     febbraio 1998.
      *DATE-COMPILED.
      *REMARKS.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.  IBM-PC.
       OBJECT-COMPUTER.  IBM-PC.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT  F-INPUT   ASSIGN "FILE-I.DAT"
                             ORGANIZATION LINE SEQUENTIAL
                             ACCESS SEQUENTIAL
                             FILE STATUS RC-F-INPUT.
      *
           SELECT  F-OUTPUT  ASSIGN "FILE-O.ARC"
                             ORGANIZATION INDEXED
                             ACCESS RANDOM
                             FILE STATUS RC-F-OUTPUT
                             RECORD KEY KEY-1-F-OUTPUT
                             ALTERNATE RECORD KEY KEY-2-F-OUTPUT
                                       WITH DUPLICATES
                             ALTERNATE RECORD KEY KEY-3-F-OUTPUT
                                       WITH DUPLICATES.
      *
           SELECT STAMPA     ASSIGN TO RANDOM SPOOL-NOME
                             FILE STATUS RC-STAMPA.
      *
       DATA DIVISION.
       FILE SECTION.
       FD  F-INPUT
           LABEL RECORD STANDARD
           BLOCK CONTAINS 0 RECORDS
           RECORD CONTAINS 150 CHARACTERS
           DATA RECORD INP-RECORD.
           COPY "F-INPUT.COP".
      *
       FD  F-OUTPUT
           RECORD CONTAINS 150 CHARACTERS
           DATA RECORD REC-F-OUTPUT.
       01  REC-F-OUTPUT.
           05  KEY-1-F-OUTPUT PIC X(24).
           05  KEY-2-F-OUTPUT PIC 9(10).
           05  FILLER         PIC X(77).
           05  KEY-3-F-OUTPUT PIC X(9).
           05  FILLER         PIC X(30).
      *
       FD  STAMPA
           LABEL RECORD STANDARD
           BLOCK CONTAINS 0 RECORDS
           RECORD CONTAINS 80 CHARACTERS
           DATA RECORD REC-STAMPA.
       01  REC-STAMPA  PIC X(80).
      ******************************************************************00000315
       WORKING-STORAGE SECTION.                                         00000320
      *    Tabellina dei FILE-STATUS - specificati nelle SELECT :
       01  RC-FILES.                                                    00000350
           05  RC-F-INPUT   PIC X(2)  VALUE ZEROS.                      00000360
           05  RC-F-OUTPUT  PIC X(2)  VALUE ZEROS.                      00000370
           05  RC-STAMPA    PIC X(2)  VALUE ZEROS.                      00000370
      *                                                                 00000380
      *    Tabellina dei FILE-STATUS - per gestione dei RETURN CODE
      *    di 4 caratteri ( anzich di 2 ).                            00000380
       01  FILES-STATUS.                                                00000410
           05  FS-F-INPUT.
               10  FS-F-INPUT-A   PIC X(2)  VALUE ZEROS.
               10  FS-F-INPUT-B   PIC X(2)  VALUE ZEROS.
           05  FS-F-OUTPUT.
               10  FS-F-OUTPUT-A  PIC X(2)  VALUE ZEROS.
               10  FS-F-OUTPUT-B  PIC X(2)  VALUE ZEROS.
           05  FS-STAMPA.
               10  FS-STAMPA-A    PIC X(2)  VALUE ZEROS.
               10  FS-STAMPA-B    PIC X(2)  VALUE ZEROS.
      *    switch - fine file
       01  EOF-FILES.                                                   00000410
           05  EOF-F-INPUT   PIC X(1)  VALUE SPACE.                     00000410
      *                                                                 00000410
       01  DATA-ELAB.                                                   00000410
           05  DATA-ELAB-AA   PIC 9(2).
           05  DATA-ELAB-MM   PIC 9(2).
           05  DATA-ELAB-GG   PIC 9(2).
      *                                                                 00000410
       01  RISP  PIC X(1).
      *                                                                 00000410
       01  WS-IN-NPOL.
           05  WS-INP-NUMPOL   PIC X(6).
           05  WS-INP-APP      PIC X(4).

      *                                                                 00000410
       01  WS-INP-DATA-SCAD    PIC 9(8).                                 00000410
      *                                                                 00000410
       01  WS-SCREEN  PIC X(2000)  VALUE ALL "".
      *                                                                 00000410
       01  CONTATORI.                                                   00000402
           05  CTR-READ-F-INPUT    PIC 9(6)  VALUE ZEROS.                 00000403
           05  CTR-WRITE-F-OUTPUT  PIC 9(6)  VALUE ZEROS.                 00000404
           05  CTR-REWR-F-OUTPUT   PIC 9(6)  VALUE ZEROS.
           05  CTR-ACQUIS-F-OUTPUT PIC 9(6)  VALUE ZEROS.
           05  CTR-SCART-F-OUTPUT  PIC 9(6)  VALUE ZEROS.                 00000404
           05  CTR-ERRORI-F-OUTPUT PIC 9(6)  VALUE ZEROS.                 00000404
           05  CTR-PAG             PIC 9(3)  VALUE ZEROS.
           05  CTR-DETTAGLI        PIC 9(2)  VALUE 99.
      *                                                                 00000410
       01  TOTALI.
           05  TOT-LETTI      PIC Z(3).Z(2)9-.
           05  TOT-SCRITTI    PIC Z(3).Z(2)9-.
           05  TOT-RISCRITTI  PIC Z(3).Z(2)9-.
           05  TOT-ACQUISITI  PIC Z(3).Z(2)9-.
           05  TOT-SCARTATI   PIC Z(3).Z(2)9-.
           05  TOT-ERRORI     PIC Z(3).Z(2)9-.
      *                                                                 00000410
       01  RIGA-01  PIC X(37)  VALUE                                     00000410
           "   ACQUISIZIONE FILE F-OUTPUT  ".
      *                                                                 00000410
       01  RIGA-02.                                                      00000410
           05  RIGA-02A  PIC X(17)  VALUE ALL "".
           05  RIGA-02B  PIC X(46)  VALUE
               "( FASE 1 :  Caricamento del file sequenziale )".
           05  RIGA-02C  PIC X(17)  VALUE ALL "".
      *                                                                 00000410
       01  RIGA-03  PIC X(33)  VALUE
           " Records letti (F-INPUT).....:   ".
      *                                                                 00000410
       01  RIGA-04  PIC X(33)  VALUE
           " Records scritti (F-OUTPUT)....: ".
      *                                                                 00000410
       01  RIGA-05  PIC X(33)  VALUE
           " Records riscritti (F-OUTPUT)..: ".
      *                                                                 00000410
       01  RIGA-05A PIC X(33)  VALUE
           " Rec. gi acquisiti (F-OUTPUT).: ".
      *                                                                 00000410
       01  RIGA-06  PIC X(33)  VALUE
           " Rec.ds gi chiusi (F-OUTPUT)..: ".
      *                                                                 00000410
       01  RIGA-07  PIC X(33)  VALUE
           " ERRORI.......................:  ".
      *                                                                 00000410
       01  RIGA-08  PIC X(26)  VALUE "Record in elaborazione :  ".        00000410
      *                                                                 00000410
       01  MSG-01  PIC X(57)  VALUE
           "OPEN ERROR FILE 'F-INPUT.DAT'         - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-02  PIC X(57)  VALUE
           "OPEN ERROR FILE 'F-OUTPUT.ARC'        - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-03  PIC X(57)  VALUE
           "IL FILE 'F-OUTPUT.ARC' E' IN USO      - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-03A  PIC X(57)  VALUE
           "BATTERE <INVIO> PER PROSEGUIRE NELL' ELABORAZIONE        ".
      *                                                                 00000410
       01  MSG-04  PIC X(57)  VALUE
           "ACCESS ERROR FILE 'F-OUTPUT.ARC'      - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-05  PIC X(57)  VALUE
           "WRITE  ERROR FILE 'F-OUTPUT.ARC'      - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-06  PIC X(57)  VALUE
           "REWRITE ERROR FILE 'F-OUTPUT.ARC'     - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-07  PIC X(57)  VALUE
           "                   *****   FINE ELABORAZIONE   *****    ".
      *                                                                 00000410
       01  MSG-08  PIC X(57)  VALUE
           "OPEN ERROR FILE 'STAMPA.DOC'          - FILE STATUS =   ,".
      *                                                                 00000410
       01  MSG-SN  PIC X(28)  VALUE
           "VUOI PROSEGUIRE ?  ( S/N ) :".
      *                                                                 00000410
       01  RECORD-F-OUTPUT.
           COPY "F-OUTPUT.COP".                                         00000420
      *                                                                 00000410
       01  RIGA-DUMMY  PIC X(80)  VALUE SPACES.
      *
       01  TESTATA-01.
           05  FILLER        PIC X(7)   VALUE "DATA : ".
           05  TESTA-01-GG   PIC Z9.
           05  FILLER        PIC X      VALUE "/".
           05  TESTA-01-MM   PIC Z9.
           05  FILLER        PIC X      VALUE "/".
           05  TESTA-01-AA   PIC Z9.
           05  FILLER        PIC X(3)   VALUE SPACES.
           05  FILLER        PIC X(49)  VALUE
               "ANOMALIE IN FASE DI ACQUISIZIONE FILE F-OUTPUT.ARC".
           05  FILLER        PIC X(4)   VALUE SPACES.
           05  FILLER        PIC X(6)   VALUE "PAG : ".
           05  TESTA-01-PAG  PIC ZZ9.
      *
       01  TESTATA-02.
           05  FILLER  PIC X(18)  VALUE SPACES.
           05  FILLER  PIC X(49)  VALUE ALL "".
           05  FILLER  PIC X(13)  VALUE SPACES.
      *
       01  TESTATA-03.
           05  FILLER  PIC X(4)   VALUE "COMP".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE "TREC".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE "RAMO".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(10)  VALUE "N. POLIZZA".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(9)   VALUE "  EFFM   ".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE "NAPP".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(3)   VALUE "NAT".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(18)  VALUE "DESCRIZIONE ERRORE".
           05  FILLER  PIC X(17)  VALUE SPACES.
      *
       01  TESTATA-04.
           05  FILLER  PIC X(4)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(10)  VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(9)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(4)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(3)   VALUE ALL "".
           05  FILLER  PIC X      VALUE SPACE.
           05  FILLER  PIC X(35)  VALUE ALL "".
      *
       01  DETTAGLIO.
           05  DETT-COMP   PIC 9(3).
           05  FILLER      PIC X(3)   VALUE SPACE.
           05  DETT-TREC   PIC X.
           05  FILLER      PIC X(4)   VALUE SPACE.
           05  DETT-RAMO   PIC 9(2).
           05  FILLER      PIC X(2)   VALUE SPACE.
           05  DETT-NPOL   PIC X(10).
           05  FILLER      PIC X      VALUE SPACE.
           05  DETT-EFFM   PIC 9(9).
           05  FILLER      PIC X      VALUE SPACE.
           05  DETT-NAPP   PIC 9(3).
           05  FILLER      PIC X(3)   VALUE SPACE.
           05  DETT-NAT    PIC X.
           05  FILLER      PIC X(2)   VALUE SPACE.
           05  DETT-DESCR  PIC X(35).
      *
       01  DESCR-01.
           05  FILLER  PIC X(13)  VALUE "GIA' ABBINATO".
           05  FILLER  PIC X(22)  VALUE SPACES.
      *
       01  DESCR-02.
           05  FILLER         PIC X(30)  VALUE
               "ERRORE READ        - STATUS : ".
           05  DESCR-02-FS-A  PIC X(2).
           05  FILLER         PIC X      VALUE ",".
           05  DESCR-02-FS-B  PIC X(2).
      *
       01  DESCR-03.
           05  FILLER         PIC X(30)  VALUE
               "ERRORE WRITE       - STATUS : ".
           05  DESCR-03-FS-A  PIC X(2).
           05  FILLER         PIC X      VALUE ",".
           05  DESCR-03-FS-B  PIC X(2).
      *
       01  DESCR-04.
           05  FILLER         PIC X(30)  VALUE
               "ERRORE REWRITE     - STATUS : ".
           05  DESCR-04-FS-A  PIC X(2).
           05  FILLER         PIC X      VALUE ",".
           05  DESCR-04-FS-B  PIC X(2).
      *
       01  SPOOL.
           05  SPOOL-NOME          PIC X(12) VALUE "PROGRAM1.STA"
      ******************************************************************00000990
       PROCEDURE DIVISION.                                              00001000
       DECLARATIVES.
       DECL SECTION.
           USE AFTER STANDARD ERROR
           PROCEDURE ON F-INPUT
                        F-OUTPUT
                        STAMPA.
           END DECLARATIVES.
      ******************************************************************00000990
       PRINCIPALE SECTION.
       MAIN.                                                            00001010
           PERFORM INIZIO      THRU  INIZIO-EX.
           PERFORM ELABORA     THRU  ELABORA-EX
                   UNTIL EOF-F-INPUT = "*".
           PERFORM FINE        THRU  FINE-EX.
       MAIN-EX.
           EXIT PROGRAM.
           STOP RUN.
      ******************************************************************
       INIZIO.
           DISPLAY WS-SCREEN LINE 1  POSITION 1
                   CONTROL "FCOLOR = BLUE".
           DISPLAY RIGA-01   LINE 1  POSITION 22
                   CONTROL "BCOLOR = BLUE, FCOLOR = GREEN".
           DISPLAY RIGA-02A  LINE 3  POSITION 1
                   CONTROL "BCOLOR = BLUE, FCOLOR = CYAN".
           DISPLAY RIGA-02C  LINE 3  POSITION 64.
           DISPLAY RIGA-02B  LINE 3  POSITION 18
                   CONTROL "BCOLOR = BLUE, FCOLOR = BROWN"
                   BLINK.
           DISPLAY RIGA-03   LINE 5  POSITION 21
                   CONTROL "BCOLOR = BLUE, FCOLOR = CYAN".
           DISPLAY RIGA-04   LINE 6  POSITION 21
           DISPLAY RIGA-05   LINE 7  POSITION 21
           DISPLAY RIGA-05A  LINE 8  POSITION 21
           DISPLAY RIGA-06   LINE 9  POSITION 21
           DISPLAY RIGA-07   LINE 10 POSITION 21
                   CONTROL "BCOLOR = BLUE, FCOLOR = MAGENTA".
           DISPLAY RIGA-08   LINE 22 POSITION 11
                   CONTROL "BCOLOR = BLUE, FCOLOR = CYAN".
      *
           MOVE CTR-READ-F-INPUT     TO TOT-LETTI.
           MOVE CTR-WRITE-F-OUTPUT   TO TOT-SCRITTI.
           MOVE CTR-REWR-F-OUTPUT    TO TOT-RISCRITTI.
           MOVE CTR-ACQUIS-F-OUTPUT  TO TOT-ACQUISITI.
           MOVE CTR-SCART-F-OUTPUT   TO TOT-SCARTATI.
           MOVE CTR-ERRORI-F-OUTPUT  TO TOT-ERRORI.
      *
           DISPLAY TOT-LETTI     LINE 5  POSITION 53.
           DISPLAY TOT-SCRITTI   LINE 6  POSITION 53.
           DISPLAY TOT-RISCRITTI LINE 7  POSITION 53.
           DISPLAY TOT-ACQUISITI LINE 8  POSITION 53.
           DISPLAY TOT-ERRORI    LINE 10 POSITION 53
                   CONTROL "BCOLOR = BLUE, FCOLOR = RED".
           DISPLAY TOT-SCARTATI  LINE 9  POSITION 53
                   CONTROL "BCOLOR = BLUE, FCOLOR = CYAN".
      *
           OPEN INPUT F-INPUT.
           CALL "C$RERR" USING FS-F-INPUT.
           IF FS-F-INPUT-A NOT = ZEROS
              DISPLAY MSG-01 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-INPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-INPUT-B LINE 24 POSITION 58
              ACCEPT  RISP LINE 24 POSITION 60
                      NO BEEP
              DISPLAY SPACES LINE 24 SIZE 80
                      CONTROL "FCOLOR = WHITE"
              MOVE "*" TO EOF-F-INPUT
              GO TO INIZIO-EX.
      *
           MOVE "35" TO FS-F-OUTPUT-A.
           PERFORM OPEN-F-OUTPUT THRU OPEN-F-OUTPUT-EX
                   UNTIL FS-F-OUTPUT-A NOT = "35".
           IF FS-F-OUTPUT-A NOT = ZEROS
              DISPLAY MSG-02 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
              ACCEPT  RISP LINE 24 POSITION 60
                      NO BEEP
              DISPLAY SPACES LINE 24 SIZE 80
                      CONTROL "FCOLOR = WHITE"
              MOVE "*" TO EOF-F-INPUT
              GO TO INIZIO-EX.
      *
      *    CALL   "PRSPOOL1" USING SPOOL.
      *    CANCEL "PRSPOOL1".
           OPEN OUTPUT STAMPA WITH LOCK.
           CALL "C$RERR" USING FS-STAMPA.
           IF FS-STAMPA-A NOT = ZEROS
              DISPLAY MSG-08 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-STAMPA-A LINE 24 POSITION 55
              DISPLAY FS-STAMPA-B LINE 24 POSITION 58
              ACCEPT  RISP LINE 24 POSITION 60
                      NO BEEP
              DISPLAY SPACES LINE 24 SIZE 80
                      CONTROL "FCOLOR = WHITE"
              MOVE "*" TO EOF-F-INPUT
              GO TO INIZIO-EX.
      *
           ACCEPT DATA-ELAB FROM DATE.
           MOVE DATA-ELAB-AA TO TESTA-01-AA.
           MOVE DATA-ELAB-MM TO TESTA-01-MM.
           MOVE DATA-ELAB-GG TO TESTA-01-GG.
      *---- LETTURA FUORI CICLO
           PERFORM READ-F-INPUT THRU READ-F-INPUT-EX.
       INIZIO-EX.     EXIT.
      ******************************************************************
      *    Apertura del file di output.
      *    N.B.  se non esiste il file, la open I/O genera un errore
      *          FILE STATUS = 35.  In tal caso, CALL ad un sottopro-
      *          gramma che ne effettua la generazione ( OPEN OUTPUT)
      ******************************************************************
       OPEN-F-OUTPUT.
           OPEN I-O F-OUTPUT.
           CALL "C$RERR" USING FS-F-OUTPUT.
           IF FS-F-OUTPUT-A = "35"
              CALL   "CREAFOUT"
              CANCEL "CREAFOUT".
       OPEN-F-OUTPUT-EX.    EXIT.
      *
      ******************************************************************
      *    E L A B O R  A Z I O N E
      ******************************************************************
       ELABORA.
           IF ( INP-RAMO      = "58" OR "59" ) AND
                INP-PROD NOT = "00"
                PERFORM READ-F-INPUT THRU READ-F-INPUT-EX
            ELSE
                INITIALIZE RECORD-F-OUTPUT
                PERFORM TRATTAMENTO   THRU TRATTAMENTO-EX
           END-IF.
       ELABORA-EX.        EXIT.
      *

       TRATTAMENTO.
           EVALUATE INP-COMP
                    WHEN "0" MOVE 2 TO OUT-COMP
                    WHEN "9" MOVE 1 TO OUT-COMP
           END-EVALUATE.
      *
           MOVE INP-RAMO TO OUT-RAMO.
           EVALUATE INP-RAMO
                    WHEN "01" MOVE 10 TO OUT-RAMO
                    WHEN "13" MOVE 1  TO OUT-RAMO
           END-EVALUATE.
      *
           MOVE INP-KEY-1 TO KEY-1-F-OUTPUT.
           MOVE "99" TO FS-F-OUTPUT-A.
           PERFORM READ-F-OUTPUT THRU READ-F-OUTPUT-EX
                   UNTIL FS-F-OUTPUT-A NOT = "99".
      *
           IF FS-F-OUTPUT-A = "23"
              PERFORM CARICA-CAMPI THRU CARICA-CAMPI-EX
              PERFORM WRITE-F-OUTPUT THRU WRITE-F-OUTPUT-EX
           ELSE
              IF FS-F-OUTPUT-A = ZEROS
                 IF OUT-ABBINATO > SPACE
                    ADD  1                  TO  CTR-SCART-F-OUTPUT
                    MOVE CTR-SCART-F-OUTPUT TO  TOT-SCARTATI
                    DISPLAY TOT-SCARTATI LINE 9 POSITION 53
                    MOVE DESCR-01           TO  DETT-DESCR
                    PERFORM STAMPA-DETTAGLIO THRU STAMPA-DETTAGLIO-EX
                 ELSE
                    IF OUT-DATA-ELABORA > 0
                       ADD  1                   TO CTR-ACQUIS-F-OUTPUT
                       MOVE CTR-ACQUIS-F-OUTPUT TO TOT-ACQUISITI
                       DISPLAY TOT-ACQUISITI LINE 8 POSITION 53
                    ELSE
                       PERFORM CARICA-CAMPI     THRU CARICA-CAMPI-EX
                       PERFORM REWRITE-F-OUTPUT THRU REWRITE-F-OUTPUT-EX
                    END-IF
                 END-IF
              ELSE
                 ADD  1 TO CTR-ERRORI-F-OUTPUT
                 MOVE CTR-ERRORI-F-OUTPUT TO TOT-ERRORI
                 DISPLAY TOT-ERRORI LINE 10 POSITION 53
                         CONTROL "BCOLOR = BLUE, FCOLOR = RED"
                 DISPLAY MSG-04 LINE 24 POSITION 1
                         CONTROL "FCOLOR = RED"
                 DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
                 DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
                 DISPLAY MSG-SN LINE 25 POSITION 1
                 MOVE FS-F-OUTPUT-A TO DESCR-02-FS-A
                 MOVE FS-F-OUTPUT-B TO DESCR-02-FS-B
                 MOVE DESCR-02     TO DETT-DESCR
                 PERFORM STAMPA-DETTAGLIO THRU STAMPA-DETTAGLIO-EX
                 PERFORM ATTESA-RISP THRU ATTESA-RISP-EX
                 IF RISP = "N"
                    MOVE "*" TO EOF-F-INPUT
                 END-IF
              END-IF
           END-IF.
      *
           IF EOF-F-INPUT = SPACE
              PERFORM READ-F-INPUT THRU READ-F-INPUT-EX
           END-IF.
      *
       TRATTAMENTO-EX.   EXIT.
      ******************************************************************
       FINE.
           CLOSE F-INPUT.
           CLOSE F-OUTPUT.
           CLOSE STAMPA.
      *
           DISPLAY RIGA-02B LINE 3  POSITION 18
                   CONTROL "BCOLOR = BLUE, FCOLOR = BROWN".
           DISPLAY SPACES   LINE 24 SIZE 80
                   CONTROL "FCOLOR = WHITE".
       FINE-EX.     EXIT.
      ******************************************************************
       ATTESA-RISP.
           MOVE SPACE TO RISP.
           PERFORM ACCETTA-RISP THRU ACCETTA-RISP-EX
                   UNTIL RISP = "S" OR
                         RISP = "N".
           DISPLAY SPACES LINE 24 SIZE 80
                   CONTROL "FCOLOR = WHITE".
           DISPLAY SPACES LINE 25 SIZE 80.
       ATTESA-RISP-EX.     EXIT.
      ******************************************************************
       ACCETTA-RISP.
           ACCEPT RISP LINE 25 POSITION 30
                  NO BEEP.
       ACCETTA-RISP-EX.     EXIT.
      ******************************************************************
       CARICA-CAMPI.
           MOVE INP-ABI           TO OUT-ABI.
           MOVE INP-CAB           TO OUT-CAB.
           MOVE INP-DATA-INCASSO  TO OUT-DT-IAS.
           MOVE INP-ORA-INCASSO   TO OUT-ORA-INCASSO.
           MOVE INP-NOME          TO OUT-RSOC.
           MOVE INP-IMPORTO       TO OUT-IMPORTO.
           MOVE INP-IMPORTO-SCAD  TO OUT-IMPORTO-SCAD.
           MOVE INP-AGENZIA       TO OUT-AGENZIA.
           MOVE INP-TERM          TO OUT-TERMINALE.
           MOVE INP-UTENTE        TO OUT-UTENTE.
           MOVE INP-CONTO         TO OUT-CONTO.
           MOVE INP-FLAG-OFFLINE  TO OUT-FLAG-OFFLINE.
           MOVE INP-ESITO         TO OUT-ESITO.
           MOVE DATA-ELAB-MM      TO OUT-MM-EL.
           MOVE DATA-ELAB-GG      TO OUT-GG-EL.
           IF DATA-ELAB-AA > 90
              ADD 1900 DATA-ELAB-AA GIVING OUT-AA-EL
           ELSE
              ADD 2000 DATA-ELAB-AA GIVING OUT-AA-EL
           END-IF.
MF0397     MOVE 0 TO OUT-CTR-GIRI.
       CARICA-CAMPI-EX.     EXIT.
      ******************************************************************
       STAMPA-DETTAGLIO.
           IF CTR-DETTAGLI > 50
              PERFORM STAMPA-TESTATA THRU STAMPA-TESTATA-EX
           END-IF.
           MOVE OUT-COMP     TO DETT-COMP.
           MOVE OUT-TREC     TO DETT-TREC.
           MOVE OUT-RAMO     TO DETT-RAMO.
           MOVE OUT-NPOL     TO DETT-NPOL.
           MOVE OUT-EFFM     TO DETT-EFFM.
           MOVE OUT-NAPP     TO DETT-NAPP.
           MOVE OUT-NAT      TO DETT-NAT.
           WRITE REC-STAMPA FROM DETTAGLIO.
           ADD 1 TO CTR-DETTAGLI.
       STAMPA-DETTAGLIO-EX.     EXIT.
      ******************************************************************
       STAMPA-TESTATA.
           ADD 1 TO CTR-PAG.
           MOVE CTR-PAG TO TESTA-01-PAG.
           WRITE REC-STAMPA FROM RIGA-DUMMY AFTER PAGE.
           WRITE REC-STAMPA FROM TESTATA-01.
           WRITE REC-STAMPA FROM TESTATA-02.
           WRITE REC-STAMPA FROM TESTATA-03 AFTER 2.
           WRITE REC-STAMPA FROM TESTATA-04.
           WRITE REC-STAMPA FROM RIGA-DUMMY.
           MOVE 0 TO CTR-DETTAGLI.
       STAMPA-TESTATA-EX.    EXIT.
      ******************************************************************
       READ-F-INPUT.
           READ F-INPUT AT END MOVE "*" TO EOF-F-INPUT.
           CALL "C$RERR" USING FS-F-INPUT.
           IF FS-F-INPUT-A = ZEROS
              IF ( INP-RAMO    = "58" OR "59" ) AND
                 INP-PROD NOT = "00"
                 NEXT SENTENCE
              ELSE
                 ADD  1 TO CTR-READ-F-INPUT
                 MOVE CTR-READ-F-INPUT TO TOT-LETTI
                 DISPLAY TOT-LETTI      LINE 5  POSITION 53
                 DISPLAY INP-DATA-SCAD LINE 22 POSITION 37
                 DISPLAY INP-COMP       LINE 22 POSITION 46
                 DISPLAY INP-AGENZIA    LINE 22 POSITION 48
                 DISPLAY INP-RAMO       LINE 22 POSITION 52
                 DISPLAY INP-PROD       LINE 22 POSITION 55
                 DISPLAY INP-NUMPOL     LINE 22 POSITION 58
                 DISPLAY INP-APP        LINE 22 POSITION 65
              END-IF
           END-IF.
       READ-F-INPUT-EX.      EXIT.
      ******************************************************************
       READ-F-OUTPUT.
           READ F-OUTPUT INTO RECORD-F-OUTPUT.
           CALL "C$RERR" USING FS-F-OUTPUT.
           IF FS-F-OUTPUT-A = "99"
              DISPLAY MSG-03 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
              DISPLAY MSG-03A LINE 25 POSITION 1
              ACCEPT RISP LINE 24 POSITION 60
                     NO BEEP
              DISPLAY SPACES LINE 24 SIZE 80
                      CONTROL "FCOLOR = WHITE"
              DISPLAY SPACES LINE 25 SIZE 80
           END-IF.
       READ-F-OUTPUT-EX.    EXIT.
      ******************************************************************
       WRITE-F-OUTPUT.
           WRITE REC-F-OUTPUT FROM RECORD-F-OUTPUT.
           CALL "C$RERR" USING FS-F-OUTPUT.
           IF FS-F-OUTPUT-A NOT = ZEROS AND
              FS-F-OUTPUT-A NOT = "02"
              ADD  1 TO CTR-ERRORI-F-OUTPUT
              MOVE CTR-ERRORI-F-OUTPUT TO TOT-ERRORI
              DISPLAY TOT-ERRORI LINE 10 POSITION 53
              DISPLAY MSG-05 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
              DISPLAY MSG-SN LINE 25 POSITION 1
              MOVE FS-F-OUTPUT-A TO DESCR-03-FS-A
              MOVE FS-F-OUTPUT-B TO DESCR-03-FS-B
              MOVE DESCR-03     TO DETT-DESCR
              PERFORM STAMPA-DETTAGLIO THRU STAMPA-DETTAGLIO-EX
              PERFORM ATTESA-RISP THRU ATTESA-RISP-EX
              IF RISP = "N"
                 MOVE "*" TO EOF-F-INPUT
              ELSE
                 NEXT SENTENCE
              END-IF
           ELSE
              ADD  1 TO CTR-WRITE-F-OUTPUT
              MOVE CTR-WRITE-F-OUTPUT TO TOT-SCRITTI
              DISPLAY TOT-SCRITTI LINE 6 POSITION 53
           END-IF.
       WRITE-F-OUTPUT-EX.    EXIT.
      ******************************************************************
       REWRITE-F-OUTPUT.
           MOVE "99" TO FS-F-OUTPUT-A.
           PERFORM RISCRIVI-F-OUTPUT THRU RISCRIVI-F-OUTPUT-EX
                   UNTIL FS-F-OUTPUT-A NOT = "99".
           IF FS-F-OUTPUT-A NOT = ZEROS AND
              FS-F-OUTPUT-A NOT = "02"
              ADD  1 TO CTR-ERRORI-F-OUTPUT
              MOVE CTR-ERRORI-F-OUTPUT TO TOT-ERRORI
              DISPLAY TOT-ERRORI LINE 10 POSITION 53
              DISPLAY MSG-06 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
              DISPLAY MSG-SN LINE 25 POSITION 1
              MOVE FS-F-OUTPUT-A TO DESCR-04-FS-A
              MOVE FS-F-OUTPUT-B TO DESCR-04-FS-B
              MOVE DESCR-04     TO DETT-DESCR
              PERFORM STAMPA-DETTAGLIO THRU STAMPA-DETTAGLIO-EX
              PERFORM ATTESA-RISP THRU ATTESA-RISP-EX
              IF RISP = "N"
                 MOVE "*" TO EOF-F-INPUT
              ELSE
                 NEXT SENTENCE
              END-IF
           ELSE
              ADD  1 TO CTR-REWR-F-OUTPUT
              MOVE CTR-REWR-F-OUTPUT TO TOT-RISCRITTI
              DISPLAY TOT-RISCRITTI LINE 7 POSITION 53
           END-IF.
       REWRITE-F-OUTPUT-EX.    EXIT.
      ******************************************************************
       RISCRIVI-F-OUTPUT.
           REWRITE REC-F-OUTPUT FROM RECORD-F-OUTPUT.
           CALL "C$RERR" USING FS-F-OUTPUT.
           IF FS-F-OUTPUT-A = "99"
              DISPLAY MSG-03 LINE 24 POSITION 1
                      CONTROL "FCOLOR = RED"
              DISPLAY FS-F-OUTPUT-A LINE 24 POSITION 55
              DISPLAY FS-F-OUTPUT-B LINE 24 POSITION 58
              DISPLAY MSG-03A LINE 25 POSITION 1
              ACCEPT RISP LINE 24 POSITION 60
                     NO BEEP
              DISPLAY SPACES LINE 24 SIZE 80
                      CONTROL "FCOLOR = WHITE"
              DISPLAY SPACES LINE 25 SIZE 80
           END-IF.
       RISCRIVI-F-OUTPUT-EX.    EXIT.
      ******************************************************************
