       IDENTIFICATION DIVISION.
       PROGRAM-ID.       SOMMAPD.
       AUTHOR.           LAU&DEB.
      *-----------------------------------------------------------------*
      *  PROGRAMMA CHE SOMMA NUMERI PARI E DISPARI PRESI DA
      *  DUE FILE DI INPUT.
      *-----------------------------------------------------------------*
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.  IBM-PC.
       OBJECT-COMPUTER.  IBM-PC.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT  REC-I-PARI ASSIGN "C:\BONON\PARI.DAT"
                              STATUS WS-STATO-PARI.
      *
           SELECT  REC-I-DISPARI ASSIGN "C:\BONON\DISPARI.DAT"
                              STATUS WS-STATO-DISPARI.
      *
           SELECT  REC-O-SOMMA ASSIGN "FILE-O.DAT"
                              STATUS WS-STATO-SOMMA.
      *
       DATA DIVISION.
       FILE SECTION.
       FD  REC-I-PARI
           LABEL RECORD STANDARD.
       01  REC-I-PARI-DAT.
           05  REC-I-PARI-NUM PIC 9(3).
           05  FILLER PIC X(2).
      *
       FD  REC-I-DISPARI
           LABEL RECORD STANDARD.
       01  REC-I-DISPARI-DAT.
           05  REC-I-DISPARI-NUM PIC 9(3).
           05  FILLER PIC X(2).
      *
       FD  REC-O-SOMMA
           LABEL RECORD OMITTED.
       01  REC-O-SOMMA-TOTALI.
           05  FILLER PIC X(1).
           05  REC-O-SOMMA-DESCR PIC X(16).
           05  REC-O-SOMMA-TOT PIC Z(4).
           05  FILLER PIC X(2).
      ******************************************************************
       WORKING-STORAGE SECTION.
      *    Dichiarazione dei FILE-STATUS - specificati nelle SELECT :
       01  WS-STATO-PARI PIC X(2).
           88  FINE-REC-I-PARI  VALUE '10'.
       01  WS-STATO-DISPARI PIC X(2).
           88  FINE-REC-I-DISPARI  VALUE '10'.
       01  WS-STATO-SOMMA PIC X(2).
           88  FINE-REC-O-SOMMA VALUE '10'.
      *    Dichiarazione delle variabili per i totali:
       01  WS-SOMMA-PARI  PIC 9(10).
       01  WS-SOMMA-DISPARI PIC 9(10).
       01  WS-SOMMA-TOTALE PIC 9(11).
      *    Dichiarazione delle variabili per la fine file:
       01  WS-FINE-PARI  PIC X(2) VALUE 'NO'.
       01  WS-FINE-DISPARI PIC X(2) VALUE 'NO'.
      ******************************************************************00000990
       PROCEDURE DIVISION.                                              00001000
       MAIN.
           PERFORM OP-INIZIALI.
           PERFORM ELABORA-SOMMA.
           PERFORM OP-FINALI.
           STOP RUN.
       EX-MAIN.
      ******************************************************************00000990
      *   Sottoprogrammi.
      ******************************************************************
       OP-INIZIALI.
           MOVE 0 TO WS-STATO-PARI WS-STATO-DISPARI WS-STATO-SOMMA.
           MOVE 0 TO WS-SOMMA-PARI WS-SOMMA-DISPARI WS-SOMMA-TOTALE.
           OPEN INPUT REC-I-PARI REC-I-DISPARI
                OUTPUT REC-O-SOMMA.
       FINE-OP-INIZIALI.
           EXIT.
      *
       ELABORA-SOMMA.
           READ REC-I-PARI.
           PERFORM SOMMA-PARI UNTIL WS-FINE-PARI = 'SI'.
           READ REC-I-DISPARI.
           PERFORM SOMMA-DISPARI UNTIL WS-FINE-DISPARI = 'SI'.
           COMPUTE WS-SOMMA-TOTALE =
                   WS-SOMMA-PARI + WS-SOMMA-DISPARI.
       FINE-ELABORA-SOMMA.
           EXIT.
      *
       SOMMA-PARI.
           COMPUTE WS-SOMMA-PARI =
                   WS-SOMMA-PARI + REC-I-PARI-NUM.
           READ REC-I-PARI AT END MOVE 'SI' TO WS-FINE-PARI.
      *    DISPLAY REC-I-PARI-NUM.
       FINE-SOMMA-PARI.
           EXIT.
      *
       SOMMA-DISPARI.
           COMPUTE WS-SOMMA-DISPARI =
                   WS-SOMMA-DISPARI + REC-I-DISPARI-NUM.
           READ REC-I-DISPARI AT END MOVE 'SI' TO WS-FINE-DISPARI.
       FINE-SOMMA-DISPARI.
           EXIT.
      *
       OP-FINALI.
           MOVE "TOTALE PARI=" TO REC-O-SOMMA-DESCR.
           MOVE WS-SOMMA-PARI TO REC-O-SOMMA-TOT.
           WRITE REC-O-SOMMA-TOTALI.
           DISPLAY REC-O-SOMMA-TOTALI LINE 25 POSITION 25.
           MOVE "TOTALE DISPARI=" TO REC-O-SOMMA-DESCR.
           MOVE WS-SOMMA-DISPARI TO REC-O-SOMMA-TOT.
           WRITE REC-O-SOMMA-TOTALI.
           DISPLAY REC-O-SOMMA-TOTALI LINE 26 POSITION 25.
           MOVE "TOTALE=" TO REC-O-SOMMA-DESCR.
           MOVE WS-SOMMA-TOTALE TO REC-O-SOMMA-TOT.
           WRITE REC-O-SOMMA-TOTALI.
           DISPLAY REC-O-SOMMA-TOTALI LINE 27 POSITION 25.
           CLOSE REC-I-PARI REC-I-DISPARI REC-O-SOMMA.
       FINE-OP-FINALI.
           EXIT.
